require ("defines")

-- Directions - North/East/South/West is 0, 2, 4, 8

debug_mode = false
tick_count = 1
tick_count_2 = 1
belts_traversed = {}

function tableLength(T)
	local count = 0
	for _ in pairs(T) do count = count + 1 end
	return count
end

game.onevent (defines.events.onplayercreated, function(event)
	if debug_mode then
	-- Add stuff into inventory at start for testing
		local player = game.getplayer(event.playerindex)
		player.insert{name="basic-transport-belt", count=100}
		player.insert{name="t1-PB-motivator", count=100}
		--player.insert{name="fast-transport-belt", count=100}
		--player.insert{name="express-transport-belt", count=100}
		player.insert{name="solar-panel", count=50}
		player.insert{name="medium-electric-pole", count=50}
		player.insert{name="PB-transformer", count=50}
		player.insert{name="steel-axe", count=1}
		player.insert{name="burner-PB-transformer", count=50}
		player.insert{name="coal", count=500}
		player.insert{name="copper-plate", count=500}
		player.insert{name="iron-plate", count=500}
		player.insert{name="raw-wood", count=500}
		player.insert{name="stone", count=500}
		player.insert{name="basic-splitter", count=50}
		
		
		game.alwaysday=true
	end
	
	if glob.motivatorlist == nil then glob.motivatorlist = {} end
	motivatorlist = glob.motivatorlist
	
	if glob.burner_transformer_list == nil then glob.burner_transformer_list = {} end
	burner_transformer_list = glob.burner_transformer_list
end)

game.onevent (defines.events.ontick, function (event)

	tick_count = (tick_count + 1) % 50
	tick_count_2 = (tick_count_2 + 1) % 36000

	if tick_count_2 == 0 then
		for k, v in pairs (burner_transformer_list) do
			if v.valid then
				for name, count1 in pairs(v.getoutputinventory().getcontents()) do
					if name == "stone" then
						v.getinventory(2).insert {name = "stone", count = count1}
					end
					v.getoutputinventory().clear()
				end
			else
				table.remove (burner_transformer_list, k)
			end
		end
	end
	
	-- Loop and deduct energy from transformers near motivators every so often
	if tick_count == 0 then
		for k, v in pairs (motivatorlist) do
			if v[1].valid then 
				nearby_coal_transformers = game.findentitiesfiltered {name = "burner-PB-transformer", area = {{v[1].position.x-1.5, v[1].position.y-1.5}, {v[1].position.x+1.5, v[1].position.y+1.5}}}
				if tableLength(nearby_coal_transformers) > 0 then
					motivator_powered = false
					for index, transformer in pairs(nearby_coal_transformers) do 
						if transformer.energy == 3200 then
							transformer.energy = 0
							motivator_powered = true
							break
						end
					end
					
					if motivator_powered then
						v[1].active = true
						findBeltMotivator (v[1])
					elseif not motivator_powered then
						v[1].active = false
						findBeltMotivator (v[1])
					end
					
				else
					nearby_transformers = game.findentitiesfiltered {name = "PB-transformer", area = {{v[1].position.x-1.5, v[1].position.y-1.5}, {v[1].position.x+1.5, v[1].position.y+1.5}}}
					
					energy_deducted = 0
					if tableLength (nearby_transformers) > 0 then
						for index, transformer in pairs(nearby_transformers) do 
							if energy_deducted < v[2] then
								if transformer.energy >= (v[2] - energy_deducted) then
									transformer.energy = transformer.energy - v[2] + energy_deducted
									energy_deducted = v[2]
								else
									energy_deducted = energy_deducted + transformer.energy
									transformer.energy = 0
								end
							else 
								break 
							end
						end
					end
					
					if energy_deducted == v[2] then
--						if not (v[1].active) then
							v[1].active = true
							findBeltMotivator (v[1])
--						end
					elseif energy_deducted < v[2] then
--						if v[1].active then
							v[1].active = false
							findBeltMotivator (v[1])
--						end
					elseif debug_mode then
						game.player.print (serpent.block("Error 001"))
					end
				end
			else 
				table.remove (motivatorlist, k)
			end
		end
	end
end)

-- Detect new belts/stuff
game.onevent (defines.events.onbuiltentity, function (event)
	ent = event.createdentity
	if ent.type == "transport-belt" then
		if (string.find(ent.name, "motivator", -9) ~= nil) then
			table.insert (motivatorlist, {ent, 0}) -- 0 being the current motive load
		end
	
		ent.active = false
		findBeltMotivator(ent)
	elseif (string.find (ent.name, "burner%-PB%-transformer", -21) ~= nil) then
		ent.insert {name="stone", count=2}
		table.insert (burner_transformer_list, ent)
	elseif ent.type == "splitter" then
		table.insert (motivatorlist, {ent, 0}) -- 0 being the current motive load
		
		ent.active = false
		findBeltMotivator(ent)
	end
end)

-- Detect removed belts
game.onevent (defines.events.onpreplayermineditem, function (event)
	ent = event.entity
	if ent.active then
		if ent.type == "transport-belt" or ent.type == "splitter" then
			removed_position = ent.position
			local next_belt = {}
			
			if (ent.direction == 0) then
				next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-0.5, ent.position.y-1}, {ent.position.x+0.5, ent.position.y-1}}}
			elseif (ent.direction == 2) then 
				next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x+1, ent.position.y-0.5}, {ent.position.x+1, ent.position.y+0.5}}}
			elseif (ent.direction == 4) then
				next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-0.5, ent.position.y+1}, {ent.position.x+0.5, ent.position.y+1}}}
			elseif (ent.direction == 6) then
				next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-1, ent.position.y-0.5}, {ent.position.x-1, ent.position.y+0.5}}}
			end
			
			if tableLength(next_belt) == 1 then
				findBeltMotivator (next_belt[1])
			else
				if (ent.direction == 0) then
					next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x-0.5, ent.position.y-1}, {ent.position.x+0.5, ent.position.y-1}}}
				elseif (ent.direction == 2) then 
					next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x+1, ent.position.y-0.5}, {ent.position.x+1, ent.position.y+0.5}}}
				elseif (ent.direction == 4) then
					next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x-0.5, ent.position.y+1}, {ent.position.x+0.5, ent.position.y+1}}}
				elseif (ent.direction == 6) then
					next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x-1, ent.position.y-0.5}, {ent.position.x-1, ent.position.y+0.5}}}
				end

				if tableLength(next_belt) == 1 then
					findBeltMotivator (next_belt[1])
				end
			end
			
			deactivateBelts (ent)
			removed_position = nil
		end
	end
end)

-- Detect belt rotations
game.onevent (defines.events.onplayerrotatedentity, function (event)
	ent = event.entity
	if ent.type == "transport-belt" then
		deactivateBelts (ent)
		findBeltMotivator (ent)
		
		oridir = ent.direction - 2
		if oridir < 0 then oridir = oridir + 8 end
		
		if (oridir == 0) then
			next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x, ent.position.y-1}, {ent.position.x, ent.position.y-1}}}
		elseif (oridir == 2) then 
			next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x+1, ent.position.y}, {ent.position.x+1, ent.position.y}}}
		elseif (oridir == 4) then
			next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x, ent.position.y+1}, {ent.position.x, ent.position.y+1}}}
		elseif (oridir == 6) then
			next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-1, ent.position.y}, {ent.position.x-1, ent.position.y}}}
		end
		
		if tableLength(next_belt) == 1 then
			findBeltMotivator (next_belt[1])
		else 
			if (oridir == 0) then
				next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x-0.5, ent.position.y-1}, {ent.position.x+0.5, ent.position.y-1}}}
			elseif (oridir == 2) then 
				next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x+1, ent.position.y-0.5}, {ent.position.x+1, ent.position.y+0.5}}}
			elseif (oridir == 4) then
				next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x-0.5, ent.position.y+1}, {ent.position.x+0.5, ent.position.y+1}}}
			elseif (oridir == 6) then
				next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x-1, ent.position.y-0.5}, {ent.position.x-1, ent.position.y+0.5}}}
			end
		
			if tableLength(next_belt) == 1 then
				findBeltMotivator (next_belt[1])
			end
		end
	end
end)


-- Deactivate incoming belts when a segment is removed
function deactivateBelts (ent)
	if not ent.active then
		return
	end
	
	ent.active = false

	-- Check 4 cardinal directions for incoming belts
	local incomingleftbelt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-1.5, ent.position.y-0.5}, {ent.position.x-0.5, ent.position.y+0.5}}}
	local incomingrightbelt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x+0.5, ent.position.y-0.5}, {ent.position.x+1.5, ent.position.y+0.5}}}
	local incomingupbelt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-0.5, ent.position.y-1.5}, {ent.position.x+0.5, ent.position.y-0.5}}}
	local incomingdownbelt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-0.5, ent.position.y+0.5}, {ent.position.x+0.5, ent.position.y+1.5}}}
	
	-- Left
	if tableLength(incomingleftbelt) == 1 then
		if incomingleftbelt[1].direction == 2 then
			deactivateBelts (incomingleftbelt[1])
		end
	end
	
	-- Right
	if tableLength(incomingrightbelt) == 1 then
		if incomingrightbelt[1].direction == 6 then
			deactivateBelts (incomingrightbelt[1])
		end
	end
	
	-- Up
	if tableLength(incomingupbelt) == 1 then
		if incomingupbelt[1].direction == 4 then
			deactivateBelts (incomingupbelt[1])
		end
	end
	
	-- Down
	if tableLength(incomingdownbelt) == 1 then
		if incomingdownbelt[1].direction == 0 then
			deactivateBelts (incomingdownbelt[1])
		end
	end
end

-- Finds the last belt along the line
function findBeltMotivator (ent)
	
	-- Check that we haven't already encountered this belt - infinite loop
	for i, v in pairs(belts_traversed) do  
		if ent.equals (v) then
			belts_traversed = {}
			return
		end
	end
	table.insert (belts_traversed, ent)
		
	if (string.find(ent.name, "motivator", -9) ~= nil or ent.type == "splitter") then
		nearby_coal_transformers = game.findentitiesfiltered {name = "burner-PB-transformer", area = {{ent.position.x-1.5, ent.position.y-1.5}, {ent.position.x+1.5, ent.position.y+1.5}}}
		if tableLength(nearby_coal_transformers) > 0 then
			coal_belt_limit = 15
		else 
			coal_belt_limit = nil
		end
		
		local current_motive_load = findCurrentMotiveLoad (ent, ent.active, coal_belt_limit)
		
		for i, v in pairs(motivatorlist) do 
			if v[1].valid then
				if ent.equals (v[1]) then
					v[2] = current_motive_load
					belts_traversed = {}
					if debug_mode then game.player.print (current_motive_load) end
				end
			end
		end
	else
		local next_belt = {}
		
		if (ent.direction == 0) then
			next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-0.5, ent.position.y-1}, {ent.position.x+0.5, ent.position.y-1}}}
		elseif (ent.direction == 2) then 
			next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x+1, ent.position.y-0.5}, {ent.position.x+1, ent.position.y+0.5}}}
		elseif (ent.direction == 4) then
			next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-0.5, ent.position.y+1}, {ent.position.x+0.5, ent.position.y+1}}}
		elseif (ent.direction == 6) then
			next_belt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-1, ent.position.y-0.5}, {ent.position.x-1, ent.position.y+0.5}}}
		end
		
		if tableLength(next_belt) == 1 then
			findBeltMotivator (next_belt[1])
		else
		
			if (ent.direction == 0) then
				next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x-0.5, ent.position.y-1}, {ent.position.x+0.5, ent.position.y-1}}}
			elseif (ent.direction == 2) then 
				next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x+1, ent.position.y-0.5}, {ent.position.x+1, ent.position.y+0.5}}}
			elseif (ent.direction == 4) then
				next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x-0.5, ent.position.y+1}, {ent.position.x+0.5, ent.position.y+1}}}
			elseif (ent.direction == 6) then
				next_belt = game.findentitiesfiltered {type = "splitter", area = {{ent.position.x-1, ent.position.y-0.5}, {ent.position.x-1, ent.position.y+0.5}}}
			end

			if tableLength(next_belt) == 1 then
				findBeltMotivator (next_belt[1])
			end
		end
	
	end
	
	belts_traversed = {}
end
 
function findCurrentMotiveLoad(ent, motivator_active, coal_belt_limit) 
	-- Calls itself recursively
	
	local current_motive_load = 0
	ent.active = motivator_active
	
	if removed_position ~= nil then
		if removed_position.x == ent.position.x and removed_position.y == ent.position.y then
			return 0, coal_belt_limit
		end
	end
	
	if coal_belt_limit ~= nil then
		coal_belt_limit = coal_belt_limit - 1
		if coal_belt_limit < 1 then 
			ent.active = false
		end
	end
			
	-- Check 4 cardinal directions for incoming belts
	local incomingleftbelt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-1, ent.position.y-0.5}, {ent.position.x-1, ent.position.y+0.5}}}
	local incomingrightbelt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x+1, ent.position.y-0.5}, {ent.position.x+1, ent.position.y+0.5}}}
	local incomingupbelt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-0.5, ent.position.y-1}, {ent.position.x+0.5, ent.position.y-1}}}
	local incomingdownbelt = game.findentitiesfiltered {type = "transport-belt", area = {{ent.position.x-0.5, ent.position.y+1}, {ent.position.x+0.5, ent.position.y+1}}}
	
	-- Left
	if tableLength(incomingleftbelt) >= 1 then
		for k, v in pairs (incomingleftbelt) do
			if v.direction == 2 and (string.find(v.name, "motivator", -9) == nil and v.type ~= "splitter") then
				temp_load, coal_belt_limit = findCurrentMotiveLoad (v, motivator_active, coal_belt_limit)
				current_motive_load = current_motive_load + temp_load
			end
		end
	end
	
	-- Right
	if tableLength(incomingrightbelt) >= 1 then
		for k, v in pairs (incomingrightbelt) do
			if v.direction == 6 and (string.find(v.name, "motivator", -9) == nil and v.type ~= "splitter") then
				temp_load, coal_belt_limit = findCurrentMotiveLoad (v, motivator_active, coal_belt_limit)
				current_motive_load = current_motive_load + temp_load
			end
		end
	end
	
	-- Up
	if tableLength(incomingupbelt) >= 1 then
		for k, v in pairs (incomingupbelt) do
			if v.direction == 4 and (string.find(v.name, "motivator", -9) == nil and v.type ~= "splitter") then
				temp_load, coal_belt_limit = findCurrentMotiveLoad (v, motivator_active, coal_belt_limit)
				current_motive_load = current_motive_load + temp_load
			end
		end
	end
	
	-- Down
	if tableLength(incomingdownbelt) >= 1 then
		for k, v in pairs (incomingdownbelt) do
			if v.direction == 0 and (string.find(v.name, "motivator", -9) == nil and v.type ~= "splitter") then
				temp_load, coal_belt_limit = findCurrentMotiveLoad (v, motivator_active, coal_belt_limit)
				current_motive_load = current_motive_load + temp_load
			end
		end
	end
	
	return current_motive_load + 400, coal_belt_limit
 end