require ("prototypes.motivator-pictures")

data:extend({
	{
	type = "transport-belt",
	name = "t1-PB-motivator",
	icon = "__PowerBelts__/graphics/t1-PB-motivator.png",
	flags = {"placeable-neutral", "player-creation"},
	minable = {hardness = 0.2, mining_time = 0.3, result = "t1-PB-motivator"},
	max_health = 50,
	corpse = "small-remnants",
	resistances =
	{
		{
		type = "fire",
		percent = 60
		}
	},
	collision_box = {{-0.4, -0.4}, {0.4, 0.4}},
	selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
	working_sound =
	{
		sound =
		{
		filename = "__base__/sound/basic-transport-belt.ogg",
		volume = 0.4
		},
		max_sounds_per_type = 3
	},
	animation_speed_coefficient = 32,
	animations =
	{
		filename = "__PowerBelts__/graphics/t1-PB-motivator.png",
		priority = "extra-high",
		width = 40,
		height = 40,
		frame_count = 16,
		direction_count = 12
	},
	belt_horizontal = basic_motivator_horizontal,
	belt_vertical = basic_motivator_vertical,
	ending_top = basic_belt_ending_top,
	ending_bottom = basic_belt_ending_bottom,
	ending_side = basic_belt_ending_side,
	starting_top = basic_belt_starting_top,
	starting_bottom = basic_belt_starting_bottom,
	starting_side = basic_belt_starting_side,
	ending_patch = ending_patch_prototype,
	fast_replaceable_group = "transport-belt",
	speed = 0.03125
	},
	{
	type = "accumulator",
	name = "PB-transformer",
	icon = "__base__/graphics/icons/basic-accumulator.png",
	flags = {"placeable-neutral", "player-creation"},
	minable = {hardness = 0.2, mining_time = 0.5, result = "PB-transformer"},
	max_health = 150,
	corpse = "medium-remnants",
	collision_box = {{-0.4, -0.4}, {0.4, 0.4}},
	selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
	energy_source =
	{
		type = "electric",
		buffer_capacity = "50kJ",
		usage_priority = "terciary",
		input_flow_limit = "75kW",
		output_flow_limit = "0kW"
	},
	picture =
	{
		filename = "__base__/graphics/entity/basic-accumulator/basic-accumulator.png",
		priority = "extra-high",
		width = 124,
		height = 103,
		shift = {0.35, -0.1},
		--shift = {0.7, -0.2},
		scale = 0.5
	},
	charge_animation =
	{
		filename = "__base__/graphics/entity/basic-accumulator/basic-accumulator-charge-animation.png",
		width = 138,
		height = 135,
		line_length = 8,
		frame_count = 24,
		--shift = {0.482, -0.638},
		shift = {0.241, -0.319},
		animation_speed = 0.5,
		scale = 0.5
	},
	charge_cooldown = 30,
	charge_light = {intensity = 0.3, size = 7},
	discharge_animation =
	{
		filename = "__base__/graphics/entity/basic-accumulator/basic-accumulator-discharge-animation.png",
		width = 147,
		height = 128,
		line_length = 8,
		frame_count = 24,
		--shift = {0.395, -0.525},
		shift = {0.197, -0.262},
		animation_speed = 0.5,
		scale = 0.5
	},
	discharge_cooldown = 60,
	discharge_light = {intensity = 0.7, size = 7},
	working_sound =
	{
		sound =
		{
		filename = "__base__/sound/accumulator-working.ogg",
		volume = 1
		},
		idle_sound = {
		filename = "__base__/sound/accumulator-idle.ogg",
		volume = 0.4
		},
		max_sounds_per_type = 5
	},
	fast_replaceable_group = "PB-transformer",
	},

	{
		type = "furnace",
		name = "burner-PB-transformer",
		icon = "__base__/graphics/icons/stone-furnace.png",
		flags = {"placeable-neutral", "placeable-player", "player-creation"},
		minable = {mining_time = 1, result = "burner-PB-transformer"},
		max_health = 150,
		corpse = "medium-remnants",
		repair_sound = { filename = "__base__/sound/manual-repair-simple.ogg" },
		mined_sound = { filename = "__base__/sound/deconstruct-bricks.ogg" },
		open_sound = { filename = "__base__/sound/machine-open.ogg", volume = 0.85 },
		close_sound = { filename = "__base__/sound/machine-close.ogg", volume = 0.75 },
		working_sound =
		{
			sound = { filename = "__base__/sound/furnace.ogg", }
		},
		resistances =
		{
			{
				type = "fire",
				percent = 80
			},
			{
				type = "explosion",
				percent = 30
			}
		},
		collision_box = {{-0.35, -0.35}, {0.35, 0.35}},
		selection_box = {{-0.4, -0.4}, {0.4, 0.5}},
		crafting_categories = {"fuel"},
		result_inventory_size = 1,
		energy_usage = "180kW",
		crafting_speed = 1,
		source_inventory_size = 1,
		energy_source =
		{
			type = "burner",
			effectivity = 1,
			fuel_inventory_size = 1,
			emissions = 0.01,
			smoke =
			{
				{
					name = "smoke",
					deviation = {0.1, 0.1},
					frequency = 0.5,
					position = {0, 0},
					starting_vertical_speed = 0.05
				}
			}
		},
		animation =
		{
			filename = "__base__/graphics/entity/stone-furnace/stone-furnace.png",
			priority = "extra-high",
			width = 81,
			height = 64,
			frame_count = 1,
			shift = {0.25, 0.025 },
			scale = 0.5
		},
		working_visualisations =
		{
			{
				north_position = {0.0, 0.0},
				east_position = {0.0, 0.0},
				south_position = {0.0, 0.0},
				west_position = {0.0, 0.0},
				animation =
				{
					filename = "__base__/graphics/entity/stone-furnace/stone-furnace-fire.png",
					priority = "extra-high",
					width = 23,
					height = 27,
					frame_count = 12,
					shift = { 0.039, 0.262},
					scale = 0.5
				},
				light = {intensity = 1, size = 1}
			}
		},
		fast_replaceable_group = "PB-transformer"
	},

})